Magellan Linux

Diff of /trunk/mage/usr/lib/mage/smage2.sh

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

revision 497 by niro, Thu Jun 7 13:16:03 2007 UTC revision 1589 by niro, Wed Dec 28 15:08:52 2011 UTC
# Line 1  Line 1 
1  #!/bin/bash  #!/bin/bash
2    # $Id$
3    
4  # compiles/installs .smage2 source install scripts  # compiles/installs .smage2 source install scripts
5  # needs pkgbuild_dir (mage)  # needs pkgbuild_dir (mage)
6    
7  # SMAGE2  # TODO: record dynlib, gz | xz database
 # $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.58 2007-06-07 13:16:03 niro Exp $  
8    
 #01.10.2004  
 # added ccache support  
 # added distcc support  
9    
10  # set default user mage.rc  # set default user mage.rc
11  : ${MAGERC="/etc/mage.rc"}  : ${MAGERC="/etc/mage.rc"}
12    
 ## setup ##  
 PKGSUFFIX="mpk"  
 SRCPKGSUFFIX="mpks"  
 SMAGENAME="$1"  
 SMAGESUFFIX="smage2"  
 MLIBDIR=/usr/lib/mage  
 SMAGEVERSION="$( < ${MLIBDIR}/version)"  
   
 ## only for tests -> normally in /etc/rc.d/init.d/functions  
 COLRED="\033[1;6m\033[31m"  
 COLGREEN="\033[1;6m\033[32m"  
 COLYELLOW="\033[1;6m\033[33m"  
 COLBLUE="\033[1;6m\033[34m"  
 COLMAGENTA="\033[1;6m\033[35m"  
 COLWHITE="\033[1;6m\033[37m"  
 COLGRAY="\033[0;6m\033[37m"  
 COLBOLD="\033[1m"  
 COLDEFAULT="\033[0m"  
   
 if [[ ${NOCOLORS} = true ]]  
 then  
  COLRED=""  
  COLGREEN=""  
  COLYELLOW=""  
  COLBLUE=""  
  COLMAGENTA=""  
  COLWHITE=""  
  COLGRAY=""  
  COLBOLD=""  
  COLDEFAULT=""  
 fi  
   
13  # export default C locale  # export default C locale
14  export LC_ALL=C  export LC_ALL=C
15    
16  source /etc/mage.rc.global  source /etc/mage.rc.global
17  source ${MAGERC}  source ${MAGERC}
18    source ${MLIBDIR}/mage4.functions.sh
19    
20    ## setup ##
21    SMAGENAME="$1"
22    SMAGEVERSION="$(< ${MLIBDIR}/version)"
23    
24  # set PKGDIR and BUILDDIR and BINDIR to MROOT  # set PKGDIR and BUILDDIR and BINDIR to MROOT
25  if [[ -n ${MROOT} ]]  if [[ -n ${MROOT} ]]
# Line 59  then Line 29  then
29   export BINDIR=${MROOT}/${BINDIR}   export BINDIR=${MROOT}/${BINDIR}
30  fi  fi
31    
32    # sources the smage file and uses state from distribution file if exist
33    # may helpful for repository support later on
34    smagesource()
35    {
36     local file="$1"
37     local mystate
38     local mycodename
39    
40     source ${file}
41    
42     [[ -n ${STATE} ]] && mystate="${STATE}"
43    
44     # do not overide if local state was broken or disabled!
45     case ${STATE} in
46     broken) return ;;
47     disabled) return ;;
48     esac
49    
50     if [ -f ${SMAGESCRIPTSDIR}/distribution ]
51     then
52     source ${SMAGESCRIPTSDIR}/distribution
53     [[ -n ${STATE} ]] && mystate="${STATE}"
54     fi
55     # now switch state and export it
56     STATE="${mystate}"
57    }
58    
59  showversion()  showversion()
60  {  {
61   echo -en "Magellan Source Install v${SMAGEVERSION} "   echo -en "Magellan Source Install v${SMAGEVERSION} "
# Line 73  die() Line 70  die()
70   exit 1   exit 1
71  }  }
72    
73    die_pipestatus()
74    {
75     # the status change if we do any parameter declarations!!
76     # dont do this anymore, keep this in mind!
77     #
78     # local pos="$1"
79     # local comment="$2"
80     #
81     # [ ${PIPESTATUS[${pos}]} -ne 0 ] && die "${comment}"
82     #
83     [ ${PIPESTATUS[$1]} -ne 0 ] && die "$2"
84    }
85    
86  xtitle()  xtitle()
87  {  {
88   if [[ ${TERM} = xterm ]]   if [[ ${TERM} = xterm ]]
# Line 129  get_db_md5_sum() Line 139  get_db_md5_sum()
139    
140  download_sources()  download_sources()
141  {  {
   
142   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0   [ -z "${SRC_URI}" ] && echo -e "\nNothing declared to download.\n" && return 0
143    
144   local EOA=${#SRC_URI[*]}   local count=${#SRC_URI[*]}
145   local my_SRC_URI   local uri
146   local my_SRC_URI_DEST   local subdir
147   local my_SRC_URI_MIRROR   local outputdir
148   local my_SOURCEDIR   local db_md5_file="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"
149   local DB_MD5_SUM_FILE="${MD5DIR}/$(basename ${SMAGENAME} .${SMAGESUFFIX}).md5"   local fetching
150   local FETCHING   local i
  local i mirror  
   
   
  # install SRCDIR/PNAME if not exist  
  [ ! -d ${SOURCEDIR}/${PNAME} ] && install -d ${SOURCEDIR}/${PNAME}  
151    
152   # check if FETCHING is needed   # check if FETCHING is needed
153   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} &> /dev/null )   if mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5
  if [[ $? = 0 ]]  
154   then   then
155   # md5's ok, no fetching needed   # md5's ok, no fetching needed
156   FETCHING=false   fetching=false
157   else   else
158   FETCHING=true   fetching=true
159   fi   fi
160    
161   for ((i=0; i < EOA; i++))   if [[ ${fetching} = true ]]
162   do   then
163   # url to file   for ((i=0; i < count; i++))
164   my_SRC_URI="$(echo ${SRC_URI[${i}]} | cut -d' ' -f1)"   do
165     # url to file
166   # subdir in sources dir; the my_SRCI_URI file goes to there   uri="${SRC_URI[${i}]%%' '*}"
  my_SRC_URI_DEST="$(echo ${SRC_URI[${i}]} | cut -d' ' -f2)"  
   
  # if my_src_uri_dest is not equal my_src_uri; than an other dir is used  
  if [[ ${my_SRC_URI_DEST} != ${my_SRC_URI} ]]  
  then  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}/${my_SRC_URI_DEST}"  
  else  
  my_SOURCEDIR="${SOURCEDIR}/${PNAME}"  
  fi  
   
  # if an mirrored file than replace first the mirror uri  
  if [[ -n $(echo ${my_SRC_URI} | grep 'mirror://') ]]  
  then  
  for mirror in ${MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|mirror:/|${mirror}/sources|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'sourceforge://') ]]  
  then  
  for mirror in ${SOURCEFORGE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|sourceforge:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnu://') ]]  
  then  
  for mirror in ${GNU_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnu:/|${mirror}|g")"  
   
  if [[ ${FETCHING} = true ]]  
  then  
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'kde://') ]]  
  then  
  for mirror in ${KDE_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|kde:/|${mirror}|g")"  
167    
168   if [[ ${FETCHING} = true ]]   # subdir in sources dir; the my_SRCI_URI file goes to there
169   then   subdir="${SRC_URI[${i}]##*' '}"
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  elif [[ -n $(echo ${my_SRC_URI} | grep 'gnome://') ]]  
  then  
  for mirror in ${GNOME_MIRRORS}  
  do  
  my_SRC_URI_MIRROR="$(echo ${my_SRC_URI} | sed "s|gnome:/|${mirror}|g")"  
170    
171   if [[ ${FETCHING} = true ]]   # if $subdir is not equal with $uri then an other dir is used
172   then   if [[ ${uri} != ${subdir} ]]
  echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI_MIRROR}${COLDEFAULT}"  
  wget \  
  --passive-ftp \  
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI_MIRROR}"  
  if [[ $? = 0 ]]  
  then  
  break  
  else  
  continue  
  fi  
  fi  
  done  
  else  
  if [[ ${FETCHING} = true ]]  
173   then   then
174   echo -e "${COLBLUE}==>${COLGREEN} fetching ${my_SRC_URI}${COLDEFAULT}"   outputdir="${SOURCEDIR}/${PNAME}/${subdir}"
175   wget \   else
176   --passive-ftp \   outputdir="${SOURCEDIR}/${PNAME}"
  --tries 3 \  
  --continue \  
  --progress bar \  
  --directory-prefix="${my_SOURCEDIR}" \  
  "${my_SRC_URI}"  
177   fi   fi
  fi  
178    
179   # unset them to be shure   echo -e "${COLBLUE}==>${COLGREEN} fetching ${uri}${COLDEFAULT}"
180   unset my_SRC_URI   mdownload --uri "${uri}" --dir "${outputdir}" || die "Could not download '${uri}'"
  unset my_SRC_URI_DEST  
  unset my_SRC_URI_MIRROR  
  unset my_SOURCEDIR  
  done  
181    
182   # recheck md5 sums   # unset them to be sure
183   echo   unset uri
184   echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"   unset subdir
185   ( cd ${SOURCEDIR}/${PNAME}; md5sum --check ${DB_MD5_SUM_FILE} ) || die "md5 failed"   unset outputdir
186   echo   done
187    
188     # recheck md5 sums after download
189     echo
190     echo -e "${COLBLUE}===${COLGREEN} Checking MD5 sums:${COLDEFAULT}"
191     mchecksum --rundir "${SOURCEDIR}/${PNAME}" --file "${db_md5_file}" --method md5 || die "md5 failed"
192     echo
193     else
194     echo -e "${COLBLUE}===${COLGREEN} All sources already fetched, nothing to do${COLDEFAULT}"
195     fi
196    
197   # not needed anymore   # not needed anymore
198   unset SRC_URI   unset SRC_URI
199  }  }
200    
201  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
202  src_prepare()  src_prepare()
203  {  {
204   echo "no src_prepare defined"   echo "no src_prepare defined"
  sleep 2  
205   return 0   return 0
206  }  }
207    
208  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
209  src_compile()  src_compile()
210  {  {
211   echo "no src_compile defined"   echo "no src_compile defined"
  sleep 2  
212   return 0   return 0
213  }  }
214    
215  # dummy function, used if that not exist in smage file  # dummy function, used if that does not exist in smage file
216    src_check()
217    {
218     echo "no src_check defined"
219     return 0
220    }
221    
222    # dummy function, used if that does not exist in smage file
223  src_install()  src_install()
224  {  {
225   echo "no src_install defined"   echo "no src_install defined"
  sleep 2  
226   return 0   return 0
227  }  }
228    
# Line 362  mconfigure() Line 241  mconfigure()
241   ./configure \   ./configure \
242   --prefix=/usr \   --prefix=/usr \
243   --host=${CHOST} \   --host=${CHOST} \
244     --build=${CHOST} \
245   --mandir=/usr/share/man \   --mandir=/usr/share/man \
246   --infodir=/usr/share/info \   --infodir=/usr/share/info \
247   --datadir=/usr/share \   --datadir=/usr/share \
# Line 405  munpack() Line 285  munpack()
285    
286   SRCFILE=$1   SRCFILE=$1
287    
288   if [ -z "$2" ]   if [[ -z $2 ]]
289   then   then
290   DEST=${BUILDDIR}   DEST=${BUILDDIR}
291   else   else
# Line 420  munpack() Line 300  munpack()
300   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
301   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
302   then   then
303   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.bz2 unpack failed."
304     else
305     pushd ${DEST} > /dev/null
306     bzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .bz2) || die ".bz2 unpack failed."
307     popd > /dev/null
308   fi   fi
309   ;;   ;;
310   gz)   gz)
# Line 428  munpack() Line 312  munpack()
312   IFTAR="${IFTAR##*.}"   IFTAR="${IFTAR##*.}"
313   if [[ ${IFTAR} = tar ]]   if [[ ${IFTAR} = tar ]]
314   then   then
315   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.gz unpack failed."
316     else
317     pushd ${DEST} > /dev/null
318     zcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .gz) || die ".gz unpack failed."
319     popd > /dev/null
320     fi
321     ;;
322     xz)
323     IFTAR="$(basename $SRCFILE .xz)"
324     IFTAR="${IFTAR##*.}"
325     if [[ ${IFTAR} = tar ]]
326     then
327     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tar.xz unpack failed."
328     else
329     pushd ${DEST} > /dev/null
330     xzcat ${SOURCEDIR}/${PNAME}/${SRCFILE} > ${DEST}/$(basename ${SRCFILE} .xz) || die ".xz unpack failed."
331     popd > /dev/null
332   fi   fi
333   ;;   ;;
334   tbz2)   tbz2|mpks|mpk)
335   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvjf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tbz2 unpack failed."
336   ;;   ;;
337   tgz)   tgz)
338   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST}   tar --no-same-owner -xvzf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".tgz unpack failed."
339     ;;
340     txz|mpkzs|mpkz)
341     tar --no-same-owner -xvJf ${SOURCEDIR}/${PNAME}/${SRCFILE} -C ${DEST} || die ".txz unpack failed."
342     ;;
343     rar)
344     unrar x ${SOURCEDIR}/${PNAME}/${SRCFILE} ${DEST}  || die ".rar unpack failed."
345     ;;
346     zip|xpi)
347     unzip ${SOURCEDIR}/${PNAME}/${SRCFILE} -d ${DEST} || die ".zip unpack failed."
348     ;;
349     rpm)
350     pushd ${DEST} > /dev/null
351     rpm2targz ${SOURCEDIR}/${PNAME}/${SRCFILE} || die "rpm2targz: .rpm unpack failed."
352     tar --no-same-owner -xvzf ${SRCFILE/.rpm/.tar.gz} || die "tar: .rpm unpack failed."
353     if [[ -f ${DEST}/${SRCFILE/.rpm/.tar.gz} ]]
354     then
355     rm ${DEST}/${SRCFILE/.rpm/.tar.gz}
356     fi
357   ;;   ;;
358   *)   *)
359   die "munpack failed"   die "munpack failed"
# Line 475  mpatch() Line 393  mpatch()
393  mlibtoolize()  mlibtoolize()
394  {  {
395   local opts="$@"   local opts="$@"
396   [[ -z ${opts} ]] && opts="--copy --force"   [[ -z ${opts} ]] && opts="--verbose --install --force"
397    
398   libtoolize ${opts} || die "running: mlibtoolize ${opts}"   libtoolize ${opts} || die "running: mlibtoolize ${opts}"
399  }  }
400    
401    mautoreconf()
402    {
403     local opts="$@"
404     [[ -z ${opts} ]] && opts="--verbose --install --force"
405    
406     autoreconf ${opts} || die "running: mautoreconf ${opts}"
407    }
408    
409  minstalldocs()  minstalldocs()
410  {  {
411   local docfiles   local docfiles
412     local doc
413   docfiles="$@"   docfiles="$@"
414    
415   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]   if [ ! -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} ]
# Line 490  minstalldocs() Line 417  minstalldocs()
417   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."   install -d ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "creating doc dirs."
418   fi   fi
419    
420   for i in ${docfiles}   for doc in ${docfiles}
421   do   do
422   cat ${i} | gzip -9c > ${i}.gz || die "gzipping docs."   if [ -f ${doc} ]
423   install -m 0644 ${SRCDIR}/${i}.gz \   then
424   ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "coping docs."   if mqueryfeature "compressdoc"
425     then
426     cat ${doc} | gzip -9c > ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "gzipping +installing ${doc}."
427     chmod 0644 ${BINDIR}/usr/share/doc/${PNAME}-${PVER}/${doc}.gz || die "fixing permissions of ${doc}."
428     else
429     install -m 0644 ${SRCDIR}/${i} ${BINDIR}/usr/share/doc/${PNAME}-${PVER} || die "installing ${doc}."
430     fi
431     fi
432   done   done
433  }  }
434    
# Line 502  mstriplibs() Line 436  mstriplibs()
436  {  {
437   local stripdir="$@"   local stripdir="$@"
438    
439   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
440   find ${stripdir} | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   [[ -z ${STRIP_DYN_LIB} ]] && STRIP_DYN_LIB="--strip-debug"
441     find ${stripdir} ! -type d | xargs file | grep "shared object" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_LIB} 2> /dev/null
442  }  }
443    
444  mstripbins()  mstripbins()
445  {  {
446   local stripdir="$@"   local stripdir="$@"
447    
448   [ -z "${stripdir}" ] && stripdir=${BINDIR}   [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
449   find ${stripdir} | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null   [[ -z ${STRIP_DYN_BIN} ]] && STRIP_DYN_BIN="--strip-debug"
450     find ${stripdir} ! -type d | xargs file | grep "executable" | grep ELF | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_DYN_BIN} 2> /dev/null
451    }
452    
453    mstripstatic()
454    {
455     local stripdir="$@"
456    
457     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
458     [[ -z ${STRIP_STATIC_LIB} ]] && STRIP_STATIC_LIB="--strip-debug"
459     find ${stripdir} ! -type d | xargs file | grep "ar archive" | cut -f 1 -d : | xargs --no-run-if-empty strip ${STRIP_STATIC_LIB} 2> /dev/null
460    }
461    
462    mstriplibtoolarchive()
463    {
464     local stripdir="$@"
465    
466     [[ -z ${stripdir} ]] && stripdir="${BINDIR}"
467     find ${stripdir} ! -type d -name \*.la | xargs file | grep "libtool library" | cut -f 1 -d : | xargs --no-run-if-empty rm -f -- 2> /dev/null
468    }
469    
470    mpurgetargets()
471    {
472     local stripdir="$@"
473     local target
474    
475     [[ -z ${stripdir} ]] && stripdir=${BINDIR}
476     # nothing to do in this case
477     [[ -z ${PURGE_TARGETS[*]} ]] && return
478    
479     for target in ${PURGE_TARGETS[*]}
480     do
481     # check if target is a regex pattern without any slashes
482     if [[ ${target} = ${target//\/} ]]
483     then
484     find ${BINDIR} -type f -name "${target}" | xargs --no-run-if-empty rm -f -- 2> /dev/null
485     else
486     rm -f -- ${target} 2> /dev/null
487     fi
488     done
489    }
490    
491    mcompressdocs()
492    {
493     local bindir="$@"
494    
495     if [ -d ${bindir}/usr/share/man ]
496     then
497     echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"
498     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/man
499     fi
500    
501     if [ -d ${bindir}/usr/share/info ]
502     then
503     echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"
504     ${MLIBDIR}/compressdoc -g -9 ${bindir}/usr/share/info
505     fi
506  }  }
507    
508  sminclude()  sminclude()
# Line 553  setup_ccache_environment() Line 544  setup_ccache_environment()
544   fi   fi
545  }  }
546    
   
547  # fixes given dependencies to match a MAGE_TARGET  # fixes given dependencies to match a MAGE_TARGET
548  # fix_mage_deps -target s/depend # <-- note -target !  # fix_mage_deps -target s/depend # <-- note -target !
549  fix_mage_deps()  fix_mage_deps()
# Line 627  EOF Line 617  EOF
617  # special tags:  # special tags:
618  #   PKGTYPE               type of pkg  #   PKGTYPE               type of pkg
619  #   INHERITS              which functions get included  #   INHERITS              which functions get included
620  #   SPECIAL_FUNCTIONS     special functions wich should also be added  #   SPECIAL_FUNCTIONS     special functions which should also be added
621  #                         warning: they get killed before the build starts !  #                         warning: they get killed before the build starts !
622    #   SPLIT_PACKAGES        names of all subpackages which are splitted from parent
623    #   SPLIT_PACKAGE_BASE    base package name for splitpackages
624    #                         (only in the resulting magefile}
625  #  #
626  #   MAGE_TREE_DEST        target destination of the generated tree  #   MAGE_TREE_DEST        target destination of the generated tree
627  #   REGEN_MAGE_TREE       set to 'true' to enable this  #   REGEN_MAGE_TREE       set to 'true' to enable this
# Line 639  build_mage_script() Line 632  build_mage_script()
632   local magefile   local magefile
633   local dest   local dest
634   local target   local target
635     local split_pkg_base
636   local sym   local sym
637   local depname   local depname
638    
# Line 646  build_mage_script() Line 640  build_mage_script()
640   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
641    
642   # determinate which suffix this mage file should get, if any   # determinate which suffix this mage file should get, if any
643   [ -n "$1" ] && target="-$1"   [[ $1 = --target ]] && shift && target="-$1"
644    
645     # mark package as splitpackage
646     [[ $1 = --split-pkg-base ]] && shift && split_pkg_base="$1"
647    
648   # name of magefile   # name of magefile
649   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"   magefile="${PNAME}${target}-${PVER}-${PBUILD}.mage"
# Line 662  build_mage_script() Line 659  build_mage_script()
659   # now build the mage file   # now build the mage file
660   > ${dest}   > ${dest}
661    
  # header  
  echo '# $Header: /home/cvsd/magellan-cvs/magellan-src/mage/usr/lib/mage/smage2.sh,v 1.58 2007-06-07 13:16:03 niro Exp $' >> ${dest}  
  echo  >> ${dest}  
   
662   # pgkname and state   # pgkname and state
663   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}   echo "PKGNAME=\"${PNAME}${target}-${PVER}-\${ARCH}-${PBUILD}\"" >> ${dest}
664   echo "STATE=\"${STATE}\"" >> ${dest}   echo "STATE=\"${STATE}\"" >> ${dest}
  echo >> ${dest}  
665    
666   # description and homepage   # description and homepage
667   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}   echo "DESCRIPTION=\"${DESCRIPTION}\"" >> ${dest}
668   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}   echo "HOMEPAGE=\"${HOMEPAGE}\"" >> ${dest}
  echo >> ${dest}  
669    
670   # special tags and vars   # special tags and vars
671   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}   echo "PKGTYPE=\"${PKGTYPE}\""  >> ${dest}
672    
673   # echo MAGE_TARGETS ## note -target is needed !   # echo MAGE_TARGETS ## note -target is needed !
674   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}   echo "MAGE_TARGETS=\"${target}\"" >> ${dest}
675   echo >> ${dest}  
676     # split package base
677     echo "SPLIT_PACKAGE_BASE=\"${split_pkg_base}\"" >> ${dest}
678    
679   # add special vars   # add special vars
680   if [ -n "${SPECIAL_VARS}" ]   if [ -n "${SPECIAL_VARS}" ]
# Line 692  build_mage_script() Line 685  build_mage_script()
685   # being tricky here :)   # being tricky here :)
686   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}   echo "${i}=\"$(eval echo \$${i})\"" >> ${dest}
687   done   done
  echo  >> ${dest}  
688   fi   fi
689    
690   # add at least all includes   # add at least all includes
# Line 704  build_mage_script() Line 696  build_mage_script()
696   do   do
697   echo -n " ${i}"  >> ${dest}   echo -n " ${i}"  >> ${dest}
698   done   done
699   echo  >> ${dest}   # a CRLF is needed here!
700     echo >> ${dest}
701   fi   fi
  echo >> ${dest}  
702    
703   # deps and provides   # deps and provides
704   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}   echo "DEPEND=\"$(fix_mage_deps "${target}" "${DEPEND}")\"" >> ${dest}
  echo >> ${dest}  
705   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}   echo "SDEPEND=\"$(fix_mage_deps "${target}" "${SDEPEND}")\"" >> ${dest}
  echo >> ${dest}  
706   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}   echo "PROVIDE=\"${PROVIDE}\"" >> ${dest}
  echo >> ${dest}  
707    
708   # add special functions   # add special functions
709   if [ -n "${SPECIAL_FUNCTIONS}" ]   if [ -n "${SPECIAL_FUNCTIONS}" ]
# Line 724  build_mage_script() Line 713  build_mage_script()
713   do   do
714   # add to mage (quotes needed !)   # add to mage (quotes needed !)
715   typeset -f "${i}" >> ${dest}   typeset -f "${i}" >> ${dest}
  echo >> ${dest}  
716   # unset to be safe (quotes needed !)   # unset to be safe (quotes needed !)
717   #unset "${i}" <-- later to get every target built   #unset "${i}" <-- later to get every target built
718   done   done
  echo  >> ${dest}  
719   fi   fi
720    
721   # pre|post-install|removes   # pre|post-install|removes
722   typeset -f preinstall >> ${dest}   typeset -f preinstall >> ${dest}
  echo  >> ${dest}  
723   typeset -f postinstall >> ${dest}   typeset -f postinstall >> ${dest}
  echo  >> ${dest}  
724   typeset -f preremove >> ${dest}   typeset -f preremove >> ${dest}
  echo  >> ${dest}  
725   typeset -f postremove >> ${dest}   typeset -f postremove >> ${dest}
  echo  >> ${dest}  
726  }  }
727    
728  regen_mage_tree()  regen_mage_tree()
729  {  {
730   local i   local subpackage
731    
732   # build them only if requested   # build them only if requested
733   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
734   then   then
735   # run it without targets   # run it without targets
736   if [ -z "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
737   then   then
738     # build for each target a mage file
739     # run it with several targets
740   echo   echo
741   build_mage_script   for subpackage in ${MAGE_TARGETS}
742     do
743     build_mage_script --target "${subpackage}"
744     done
745   echo   echo
  else  
746    
747   # build for each target an mage file   # run it for splitpackages
748     elif [[ -n ${SPLIT_PACKAGES} ]]
749     then
750     local split_pkg_base="${PNAME}"
751     # save smage environment
752     split_save_variables
753     # build for each subpackage a mage file
754   # run it with several targets   # run it with several targets
755   for i in ${MAGE_TARGETS}   echo
756     for subpackage in ${SPLIT_PACKAGES}
757   do   do
758   echo   # get the right variables for the split
759   build_mage_script "${i}"   export PNAME="${subpackage}"
760   echo   split_info_${subpackage}
761     # get the preinstall etc
762     split_export_inherits ${subpackage}
763     build_mage_script --split-pkg-base "${split_pkg_base}"
764     # delete split preinstall etc
765     split_delete_inherits ${subpackage}
766     # restore smage environment
767     split_restore_variables
768   done   done
769     echo
770     # unset all saved smage variables
771     split_unset_variables
772    
773     else
774     echo
775     build_mage_script
776     echo
777   fi   fi
778   fi   fi
779    
# Line 795  regen_mage_tree() Line 804  regen_mage_tree()
804   unset postremove   unset postremove
805  }  }
806    
807    split_save_variables()
808    {
809     export SAVED_PNAME="${PNAME}"
810     export SAVED_PVER="${PVER}"
811     export SAVED_PBUILD="${PBUILD}"
812     export SAVED_PCATEGORIE="${PCATEGORIE}"
813     export SAVED_DESCRIPTION="${DESCRIPTION}"
814     export SAVED_HOMEPAGE="${HOMEPAGE}"
815     export SAVED_SPECIAL_VARS="${SPECIAL_VARS}"
816     export SAVED_STATE="${STATE}"
817     export SAVED_PKGTYPE="${PKGTYPE}"
818     export SAVED_INHERITS="${INHERITS}"
819     export SAVED_DEPEND="${DEPEND}"
820     export SAVED_SDEPEND="${SDEPEND}"
821     export SAVED_PROVIDE="${PROVIDE}"
822     export SAVED_PKGTYPE="${PKGTYPE}"
823    
824     # special handling needed for mage features
825     # pkgbuild
826     mqueryfeature "pkgbuild" && export SAVED_FEATURE_PKGBUILD="pkgbuild"
827     mqueryfeature "!pkgbuild" && export SAVED_FEATURE_PKGBUILD="!pkgbuild"
828     # strip
829     mqueryfeature "strip" && export SAVED_FEATURE_STRIP="strip"
830     mqueryfeature "!strip" && export SAVED_FEATURE_STRIP="!strip"
831     # libtool
832     mqueryfeature "libtool" && export SAVED_FEATURE_LIBTOOL="libtool"
833     mqueryfeature "!libtool" && export SAVED_FEATURE_LIBTOOL="!libtool"
834     # compressdoc
835     mqueryfeature "compressdoc" && export SAVED_FEATURE_COMPRESSDOC="compressdoc"
836     mqueryfeature "!compressdoc" && export SAVED_FEATURE_COMPRESSDOC="!compressdoc"
837    
838     # bindir too
839     export SAVED_BINDIR="${BINDIR}"
840    
841     # export the SPLIT_PACKAGE_BASE
842     export SPLIT_PACKAGE_BASE="${SAVED_PNAME}"
843    
844     # functions
845     if [[ ! -z $(typeset -f preinstall) ]]
846     then
847     # rename the old one
848     local saved_preinstall
849     saved_preinstall=SAVED_$(typeset -f preinstall)
850     eval "${saved_preinstall}"
851     export -f SAVED_preinstall
852     fi
853    
854     if [[ ! -z $(typeset -f postinstall) ]]
855     then
856     # rename the old one
857     local saved_postinstall
858     saved_postinstall=SAVED_$(typeset -f postinstall)
859     eval "${saved_postinstall}"
860     export -f SAVED_postinstall
861     fi
862    
863     if [[ ! -z $(typeset -f preremove) ]]
864     then
865     # rename the old one
866     local saved_preremove
867     saved_preremove=SAVED_$(typeset -f preremove)
868     eval "${saved_preremove}"
869     export -f SAVED_preremove
870     fi
871    
872     if [[ ! -z $(typeset -f postremove) ]]
873     then
874     # rename the old one
875     local saved_postremove
876     saved_postremove=SAVED_$(typeset -f postremove)
877     eval "${saved_postremove}"
878     export -f SAVED_postremove
879     fi
880    }
881    
882    split_restore_variables()
883    {
884     export PNAME="${SAVED_PNAME}"
885     export PVER="${SAVED_PVER}"
886     export PBUILD="${SAVED_PBUILD}"
887     export PCATEGORIE="${SAVED_PCATEGORIE}"
888     export DESCRIPTION="${SAVED_DESCRIPTION}"
889     export HOMEPAGE="${SAVED_HOMEPAGE}"
890     export SPECIAL_VARS="${SAVED_SPECIAL_VARS}"
891     export STATE="${SAVED_STATE}"
892     export PKGTYPE="${SAVED_PKGTYPE}"
893     export INHERITS="${SAVED_INHERITS}"
894     export DEPEND="${SAVED_DEPEND}"
895     export SDEPEND="${SAVED_SDEPEND}"
896     export PROVIDE="${SAVED_PROVIDE}"
897     export PKGTYPE="${SAVED_PKGTYPE}"
898    
899     # special handling needed for mage features
900     # pkgbuild
901     msetfeature "${SAVED_FEATURE_PKGBUILD}"
902     # strip
903     msetfeature "${SAVED_FEATURE_STRIP}"
904     # libtool
905     msetfeature "${SAVED_FEATURE_LIBTOOL}"
906     # compressdoc
907     msetfeature "${SAVED_FEATURE_COMPRESSDOC}"
908    
909     # bindir too
910     export BINDIR="${SAVED_BINDIR}"
911    
912     # functions
913     if [[ ! -z $(typeset -f SAVED_preinstall) ]]
914     then
915     # rename the old one
916     local saved_preinstall
917     saved_preinstall=$(typeset -f SAVED_preinstall)
918     eval "${saved_preinstall/SAVED_/}"
919     export -f preinstall
920     fi
921    
922     if [[ ! -z $(typeset -f SAVED_postinstall) ]]
923     then
924     # rename the old one
925     local saved_postinstall
926     saved_postinstall=$(typeset -f SAVED_postinstall)
927     eval "${saved_postinstall/SAVED_/}"
928     export -f postinstall
929     fi
930    
931     if [[ ! -z $(typeset -f SAVED_preremove) ]]
932     then
933     # rename the old one
934     local saved_preremove
935     saved_preremove=$(typeset -f SAVED_preremove)
936     eval "${saved_preremove/SAVED_/}"
937     export -f preremove
938     fi
939    
940     if [[ ! -z $(typeset -f SAVED_postremove) ]]
941     then
942     # rename the old one
943     local saved_postremove
944     saved_postremove=$(typeset -f SAVED_postremove)
945     eval "${saved_postremove/SAVED_/}"
946     export -f postremove
947     fi
948    }
949    
950    split_unset_variables()
951    {
952     # unset saved vars; not needed anymore
953     unset SAVED_PNAME
954     unset SAVED_PVER
955     unset SAVED_PBUILD
956     unset SAVED_PCATEGORIE
957     unset SAVED_DESCRIPTION
958     unset SAVED_HOMEPAGE
959     unset SAVED_SPECIAL_VARS
960     unset SAVED_STATE
961     unset SAVED_PKGTYPE
962     unset SAVED_INHERITS
963     unset SAVED_DEPEND
964     unset SAVED_SDEPEND
965     unset SAVED_PROVIDE
966     unset SAVED_BINDIR
967     unset SAVED_PKGTYPE
968     unset SAVED_FEATURE_PKGBUILD
969     unset SAVED_FEATURE_STRIP
970     unset SAVED_FEATURE_LIBTOOL
971     unset SAVED_FEATURE_COMPRESSDOC
972     unset SPLIT_PACKAGE_BASE
973     unset -f SAVED_preinstall
974     unset -f SAVED_postinstall
975     unset -f SAVED_preremove
976     unset -f SAVED_postremove
977    }
978    
979    split_export_inherits()
980    {
981     local subpackage="$1"
982     local func
983     local newfunc
984    
985     for func in preinstall postinstall preremove postremove
986     do
987     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
988     then
989     newfunc=$(typeset -f ${func}_${subpackage})
990     newfunc="${newfunc/_${subpackage} (/ (}"
991     eval "${newfunc}"
992     fi
993     done
994    }
995    
996    split_delete_inherits()
997    {
998     local subpackage="$1"
999     local func
1000    
1001     for func in preinstall postinstall preremove postremove
1002     do
1003     if [[ ! -z $(typeset -f ${func}_${subpackage}) ]]
1004     then
1005     unset -f ${func}
1006     fi
1007     done
1008     }
1009    
1010  export_inherits()  export_inherits()
1011  {  {
1012   local include="$1"   local include="$1"
# Line 860  generate_package_md5sum() Line 1072  generate_package_md5sum()
1072   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"   pkgname="${pname}${target}-${pver}-${parch}-${pbuild}"
1073    
1074   # build pkg-md5-sum only if requested   # build pkg-md5-sum only if requested
1075   if [[ ${REGEN_MAGE_TREE} = true ]]   if mqueryfeature regentree
1076   then   then
1077   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"   echo -ne "${COLBLUE}===${COLGREEN} generating md5's for ${pkgname}.${PKGSUFFIX} ... ${COLDEFAULT}"
1078    
# Line 875  generate_package_md5sum() Line 1087  generate_package_md5sum()
1087   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}   : ${MAGE_TREE_DEST=${BUILDDIR}/mage-tree}
1088    
1089   # setup md5 dir   # setup md5 dir
1090   dest="${MAGE_TREE_DEST}/${pcat}/${pname}/md5"   dest="${MAGE_TREE_DEST}/${pcat}/${pname}${target}/md5"
1091   install -d ${dest}   install -d ${dest}
1092    
1093   # gen md5sum   # gen md5sum
# Line 913  source_pkg_build() Line 1125  source_pkg_build()
1125   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"   echo -e "${COLGREEN}Source package ${COLBLUE}${PNAME}-${PVER}-${PBUILD}.${SRCPKGSUFFIX} ${COLGREEN}successfully builded.${COLDEFAULT}"
1126  }  }
1127    
1128    step_by_step()
1129    {
1130     if mqueryfeature stepbystep
1131     then
1132     echo -e "${COLRED}Step-by-step enabled! Paused after $1.${COLDEFAULT}"
1133     echo "Press [enter] to continue"
1134     read
1135     fi
1136    }
1137    
1138    
1139  # print out our version  # print out our version
1140  showversion  showversion
# Line 925  then Line 1147  then
1147   exit 1   exit 1
1148  fi  fi
1149    
1150    # load supported mage features
1151    load_mage_features
1152    
1153  # updating smage2-scripts  # updating smage2-scripts
1154  if [[ $1 = update ]]  if [[ $1 = update ]]
1155  then  then
# Line 939  fi Line 1164  fi
1164  # creates md5sums for smages to given dir  # creates md5sums for smages to given dir
1165  if [[ $1 = calcmd5 ]]  if [[ $1 = calcmd5 ]]
1166  then  then
1167   if [ $# -ge 3 ]   if [ $# -ge 2 ]
1168   then   then
1169   SMAGENAME="$2"   SMAGENAME="$2"
1170   MD5DIR="$3"   MD5DIR="$3"
1171   source ${SMAGENAME} || die "download source failed"   [[ -z ${MD5DIR} ]] && MD5DIR="$(dirname ${SMAGENAME})/md5"
1172    
1173     smagesource ${SMAGENAME} || die "download source failed"
1174    
1175   # overridable sourcedir; must be declared after source of the smage2   # overridable sourcedir; must be declared after source of the smage2
1176   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"   CALC_SOURCEDIR="${CALC_SOURCEDIR:="${SOURCEDIR}/${PNAME}"}"
# Line 995  then Line 1222  then
1222   echo   echo
1223   else   else
1224   echo "Usage: Calculating MD5 Sums:"   echo "Usage: Calculating MD5 Sums:"
1225   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME /path/to/MD5DIR"   echo "    $(basename $0) calcmd5 /path/to/SMAGENAME [/path/to/MD5DIR]"
1226   echo   echo
1227   echo   echo
1228   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."   echo "Export the CALC_SOURCEDIR variable to override current SOURCEDIRs."
# Line 1017  then Line 1244  then
1244   # get smage   # get smage
1245   SMAGENAME="$2"   SMAGENAME="$2"
1246   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1247   source ${SMAGENAME} || die "download source failed"   smagesource ${SMAGENAME} || die "download source failed"
1248    
1249   download_sources   download_sources
1250   exit 0   exit 0
# Line 1029  then Line 1256  then
1256   # set correct SMAGENAME   # set correct SMAGENAME
1257   SMAGENAME="$2"   SMAGENAME="$2"
1258   MD5DIR="$(dirname ${SMAGENAME})/md5"   MD5DIR="$(dirname ${SMAGENAME})/md5"
1259   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1260    
1261   regen_mage_tree   regen_mage_tree
1262    
1263   # build md5sum for existing packages   # build several targets
1264   generate_package_md5sum \   if [[ -n ${MAGE_TARGETS} ]]
1265   --pcat "${PCATEGORIE}" \   then
1266   --pname "${PNAME}" \   for target in ${MAGE_TARGETS}
1267   --pver "${PVER}" \   do
1268   --pbuild "${PBUILD}" \   # build md5sum for existing packages
1269   --parch "${ARCH}" \   generate_package_md5sum \
1270   --target "${target}"   --pcat "${PCATEGORIE}" \
1271     --pname "${PNAME}" \
1272     --pver "${PVER}" \
1273     --pbuild "${PBUILD}" \
1274     --parch "${ARCH}" \
1275     --target "${target}"
1276     done
1277    
1278     # build several subpackages
1279     elif [[ -n ${SPLIT_PACKAGES} ]]
1280     then
1281     split_save_variables
1282     for subpackage in ${SPLIT_PACKAGES}
1283     do
1284     # get the right variables for the split
1285     export PNAME="${subpackage}"
1286     split_info_${subpackage}
1287     # build md5sum for existing packages
1288     generate_package_md5sum \
1289     --pcat "${PCATEGORIE}" \
1290     --pname "${PNAME}" \
1291     --pver "${PVER}" \
1292     --pbuild "${PBUILD}" \
1293     --parch "${ARCH}"
1294     # restore smage environment
1295     split_restore_variables
1296     done
1297     # unset all saved smage variables
1298     split_unset_variables
1299    
1300     else
1301     # build md5sum for existing packages
1302     generate_package_md5sum \
1303     --pcat "${PCATEGORIE}" \
1304     --pname "${PNAME}" \
1305     --pver "${PVER}" \
1306     --pbuild "${PBUILD}" \
1307     --parch "${ARCH}"
1308     fi
1309    
1310   exit 0   exit 0
1311  fi  fi
# Line 1053  then Line 1318  then
1318    
1319   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"   echo -e "${COLGREEN}create-src-tarball called for ${COLBLUE}${SMAGENAME}${COLGREEN} ...${COLDEFAULT}"
1320    
1321   source ${SMAGENAME} || die "regen: smage2 not found"   smagesource ${SMAGENAME} || die "regen: smage2 not found"
1322    
1323   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1324   then   then
# Line 1069  fi Line 1334  fi
1334  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]  if [ "$1" == "--src-tarball" -a -n "$2" ] || [ "$1" == "-st" -a -n "$2" ]
1335  then  then
1336   SRCPKGTARBALL="${2}"   SRCPKGTARBALL="${2}"
1337   USE_SRC_PKG_TARBALL=true   msetfeature "srcpkgtarball"
1338    
1339   # abort if given file is not a source pkg   # abort if given file is not a source pkg
1340   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."   [[ ${SRCPKGTARBALL##*.} != ${SRCPKGSUFFIX} ]] && die "${SRCPKGTARBALL} is not a valid src-pkg file."
# Line 1102  fi Line 1367  fi
1367  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"  [ -z "${CFLAGS}" ] && die "no CFLAGS variable found in ${MAGERC}"
1368  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"  [ -z "${CXXFLAGS}" ] && die "no CXXFLAGS variable found in ${MAGERC}"
1369    
1370  source ${SMAGENAME} || die "source failed"  smagesource ${SMAGENAME} || die "source failed"
1371  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"  PKGNAME="${PNAME}-${PVER}-${ARCH}-${PBUILD}"
1372  MD5DIR="$(dirname ${SMAGENAME})/md5"  MD5DIR="$(dirname ${SMAGENAME})/md5"
1373    SMAGE_LOG_CMD="tee -a /var/log/smage/${PKGNAME}.log"
1374    
1375  xtitle "Compiling ${PKGNAME}"  xtitle "Compiling ${PKGNAME}"
1376  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"  echo -e "${COLGREEN}Compiling ${PKGNAME}${COLDEFAULT}"
# Line 1112  echo -e "${COLGREEN}Compiling ${PKGNAME} Line 1378  echo -e "${COLGREEN}Compiling ${PKGNAME}
1378  # auto regen mage tree if requested  # auto regen mage tree if requested
1379  regen_mage_tree  regen_mage_tree
1380    
1381  if [[ ${CREATE_SRC_PKG_TARBALL} = true ]]  if mqueryfeature "srcpkg"
1382  then  then
1383   if [[ -d ${SOURCEDIR}/${PNAME} ]]   if [[ -d ${SOURCEDIR}/${PNAME} ]]
1384   then   then
# Line 1122  then Line 1388  then
1388  fi  fi
1389    
1390  # download sources  # download sources
1391  [[ ${USE_SRC_PKG_TARBALL} != true ]] && download_sources  mqueryfeature "srcpkgtarball" || download_sources
1392    
1393  # fixes some issues with these functions  # fixes some issues with these functions
1394  export -f src_prepare || die "src_prepare export failed"  export -f src_prepare || die "src_prepare export failed"
1395  export -f src_compile || die "src_compile export failed"  export -f src_compile || die "src_compile export failed"
1396    export -f src_check || die "src_check export failed"
1397  export -f src_install || die "src_install export failed"  export -f src_install || die "src_install export failed"
1398    
1399  # fixes some compile issues  # fixes some compile issues
# Line 1136  export CXXFLAGS="${CFLAGS}" || die "CXXF Line 1403  export CXXFLAGS="${CFLAGS}" || die "CXXF
1403  export BINDIR="${BINDIR}" || die "BINDIR export failed"  export BINDIR="${BINDIR}" || die "BINDIR export failed"
1404  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"  export MAKEOPTS="${MAKEOPTS}" || die "MAKEOPTS export failed"
1405    
   
1406  # setup distcc  # setup distcc
1407  # setup for distcc goes *before* ccache, so ccache comes before distcc in path  # setup for distcc goes *before* ccache, so ccache comes before distcc in path
1408  [[ ${SMAGE_USE_DISTCC} = true ]] && setup_distcc_environment  mqueryfeature "distcc" && setup_distcc_environment
1409    
1410  # setup ccache  # setup ccache
1411  [[ ${SMAGE_USE_CCACHE} = true ]] && setup_ccache_environment  mqueryfeature "ccache" && setup_ccache_environment
1412    
1413  # small sleep to show our settings  # clean up builddir if a previously one exist
 sleep 1  
   
 # cleans up build if a previously one exists  
1414  if [ -d ${BUILDDIR} ]  if [ -d ${BUILDDIR} ]
1415  then  then
1416   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."   rm -rf ${BUILDDIR}/* || die "couldn't cleanup \$BUILDDIR."
1417  fi  fi
1418  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."  install -d ${BUILDDIR} || die "couldn't create \$BUILDDIR."
1419    
1420  # cleans up srcdir if a previously unpacked one exists  # clean up srcdir if a previously unpacked one exist
1421  if [ -d ${SRCDIR} ]  if [ -d ${SRCDIR} ]
1422  then  then
1423   rm -rf ${SRCDIR}   rm -rf ${SRCDIR}
1424  fi  fi
1425    
1426  # cleans up bindir if a previous build exists or creates a new one  # clean up bindir if a previous build exist or create a new one
1427  if [ -d ${BINDIR} ]  if [ -d ${BINDIR} ]
1428  then  then
1429   rm -rf ${BINDIR}   rm -rf ${BINDIR}
1430  fi  fi
1431  install -d ${BINDIR} || die "couldn't create \$BINDIR."  install -d ${BINDIR} || die "couldn't create \$BINDIR."
1432    
1433  # cleans up package temp dir if a previous build exists  # clean up package temp dir if a previous build exist
1434  if [ -d ${BUILDDIR}/${PKGNAME} ]  if [ -d ${BUILDDIR}/${PKGNAME} ]
1435  then  then
1436   rm -rf ${BUILDDIR}/${PKGNAME}   rm -rf ${BUILDDIR}/${PKGNAME}
1437  fi  fi
1438    
1439  # cleans up timestamp if one exists  # setup build logging
1440  if [ -f /var/tmp/timestamp ]  [[ ! -d /var/log/smage ]] && install -d /var/log/smage
1441    echo -e "### Build started on $(date) ###\n" > /var/log/smage/${PKGNAME}.log
1442    
1443    src_prepare | ${SMAGE_LOG_CMD}
1444    die_pipestatus 0 "src_prepare failed"
1445    step_by_step $_
1446    
1447    src_compile | ${SMAGE_LOG_CMD}
1448    die_pipestatus 0 "src_compile failed"
1449    step_by_step $_
1450    
1451    # only run checks if requested
1452    if mqueryfeature "!check"
1453  then  then
1454   mage rmstamp   echo "!check detected; src_check() will not be run!" | ${SMAGE_LOG_CMD}
1455     step_by_step src_check
1456    else
1457     src_check | ${SMAGE_LOG_CMD}
1458     die_pipestatus 0 "src_check failed"
1459     step_by_step $_
1460  fi  fi
1461    
1462  src_prepare || die "src_prepare failed"  # build several subpackages
1463  src_compile || die "src_compile failed"  if [[ -n ${SPLIT_PACKAGES} ]]
1464  src_install || die "src_install failed"  then
1465     # save bindir & pname
1466     split_save_variables
1467     export SAVED_BINDIR="${BINDIR}"
1468     for subpackage in ${SPLIT_PACKAGES}
1469     do
1470     if typeset -f src_install_${subpackage} > /dev/null
1471     then
1472     # export subpackage bindir
1473     export BINDIR="${SAVED_BINDIR}_${subpackage}"
1474     # export PNAME, several internal function and include
1475     # rely on this variable
1476     export PNAME="${subpackage}"
1477    
1478     echo
1479     echo -en "${COLBLUE}*** ${COLDEFAULT}"
1480     echo -en "  Running ${COLGREEN}split src_install()${COLDEFAULT}"
1481     echo -en " for subpkg: ${COLBLUE}${PNAME}${COLDEFAULT}"
1482     echo -e " - basepkg: ${COLBLUE}${SPLIT_PACKAGE_BASE}${COLDEFAULT} ..."
1483    
1484     src_install_${subpackage} | ${SMAGE_LOG_CMD}
1485     die_pipestatus 0 "src_install_${subpackage} failed"
1486     step_by_step $_
1487     fi
1488     done
1489     # restore bindir & pname
1490     split_restore_variables
1491     # unset all saved smage variables
1492     split_unset_variables
1493    else
1494     src_install | ${SMAGE_LOG_CMD}
1495     die_pipestatus 0 "src_install failed"
1496     step_by_step $_
1497    fi
1498    
1499    if mqueryfeature "!compressdoc"
1500    then
1501     echo -e "!compressdoc detected; documentation will not be compressed ..."
1502    else
1503     # compressing doc, info & man files
1504     if [[ -n ${SPLIT_PACKAGES} ]]
1505     then
1506     for subpackage in ${SPLIT_PACKAGES}
1507     do
1508     mcompressdocs ${BINDIR}_${subpackage}
1509     done
1510     else
1511     mcompressdocs ${BINDIR}
1512     fi
1513    fi
1514    
1515  # compressing doc, info & man files  if mqueryfeature "!libtool"
 if [ -d ${BUILDDIR}/builded/usr/share/man ]  
1516  then  then
1517   echo -e "${COLBLUE}===${COLGREEN} compressing man-pages ...${COLDEFAULT}"   if [[ -n ${SPLIT_PACKAGES} ]]
1518   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/man   then
1519     for subpackage in ${SPLIT_PACKAGES}
1520     do
1521     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives for '${subpackage}' ...${COLDEFAULT}"
1522     mstriplibtoolarchive ${BINDIR}_${subpackage}
1523     done
1524     else
1525     echo -e "${COLBLUE}===${COLGREEN} stripping libtool archives ...${COLDEFAULT}"
1526     mstriplibtoolarchive ${BINDIR}
1527     fi
1528  fi  fi
1529    
1530  if [ -d ${BUILDDIR}/builded/usr/share/info ]  if mqueryfeature "purge"
1531  then  then
1532   echo -e "${COLBLUE}===${COLGREEN} compressing info-pages ...${COLDEFAULT}"   if [[ -n ${SPLIT_PACKAGES} ]]
1533   ${MLIBDIR}/compressdoc -g -9 ${BUILDDIR}/builded/usr/share/info   then
1534     for subpackage in ${SPLIT_PACKAGES}
1535     do
1536     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets in '${subpackage}' ...${COLDEFAULT}"
1537     mpurgetargets ${BINDIR}_${subpackage}
1538     done
1539     else
1540     echo -e "${COLBLUE}===${COLGREEN} purging all purge targets ...${COLDEFAULT}"
1541     mpurgetargets ${BINDIR}
1542     fi
1543  fi  fi
1544    
1545  # stripping all bins and libs  # stripping all bins and libs
1546  case ${NOSTRIP} in  if mqueryfeature "!strip"
1547   true|TRUE|yes|y)  then
1548   echo -e "NOSTRIP=true detected; Package will not be stripped ..."   echo -e "!strip detected; Package will not be stripped ..."
1549   ;;  else
1550   *)   if [[ -n ${SPLIT_PACKAGES} ]]
1551   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"   then
1552   mstripbins ${BINDIR}   for subpackage in ${SPLIT_PACKAGES}
1553   echo -e "${COLBLUE}===${COLGREEN} stripping libraries ...${COLDEFAULT}"   do
1554   mstriplibs ${BINDIR}   echo -e "${COLBLUE}===${COLGREEN} stripping binaries for '${subpackage}' ...${COLDEFAULT}"
1555   ;;   mstripbins ${BINDIR}_${subpackage}
1556  esac   echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries for '${subpackage}' ...${COLDEFAULT}"
1557     mstriplibs ${BINDIR}_${subpackage}
1558  # the new buildpkg command   echo -e "${COLBLUE}===${COLGREEN} stripping static libraries for '${subpackage}' ...${COLDEFAULT}"
1559  case ${NOPKGBUILD} in   mstripstatic ${BINDIR}_${subpackage}
1560   true|TRUE|yes|y)   done
1561   echo -e "NOPGKBUILD=true detected; Package will not be build ..."   else
1562   ;;   echo -e "${COLBLUE}===${COLGREEN} stripping binaries ...${COLDEFAULT}"
1563   *)   mstripbins ${BINDIR}
1564     echo -e "${COLBLUE}===${COLGREEN} stripping dynamic libraries ...${COLDEFAULT}"
1565     mstriplibs ${BINDIR}
1566     echo -e "${COLBLUE}===${COLGREEN} stripping static libraries ...${COLDEFAULT}"
1567     mstripstatic ${BINDIR}
1568     fi
1569    fi
1570    
1571    if mqueryfeature "!buildpkg"
1572    then
1573     echo -e "!buildpkg detected; Package will not be build ..."
1574    else
1575   # build several targets   # build several targets
1576   if [ -n "${MAGE_TARGETS}" ]   if [[ -n ${MAGE_TARGETS} ]]
1577   then   then
1578   for target in ${MAGE_TARGETS}   for target in ${MAGE_TARGETS}
1579   do   do
1580   # check if an special target_pkgbuild exists   # check if a special target_pkgbuild exists
1581   if typeset -f ${target}_pkgbuild > /dev/null   if typeset -f ${target}_pkgbuild > /dev/null
1582   then   then
1583   # run it   # run it
# Line 1243  case ${NOPKGBUILD} in Line 1599  case ${NOPKGBUILD} in
1599    
1600   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"   echo -e "${COLGREEN}\nPackage ${PNAME}-${target}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1601   done   done
1602    
1603     # build several subpackages
1604     elif [[ -n ${SPLIT_PACKAGES} ]]
1605     then
1606     split_save_variables
1607     for subpackage in ${SPLIT_PACKAGES}
1608     do
1609     # get the right variables for the split
1610     export PNAME="${subpackage}"
1611     split_info_${PNAME}
1612    
1613     # jump to next one if !buildpkg is set in split_info
1614     mqueryfeature "!buildpkg" && continue
1615    
1616     # check if an special subpackage_pkgbuild exists
1617     if typeset -f ${PNAME}_pkgbuild > /dev/null
1618     then
1619     # run it
1620     ${PNAME}_pkgbuild
1621     fi
1622     # now create the target package
1623     ${MLIBDIR}/pkgbuild_dir.sh \
1624     "${PNAME}-${PVER}-${ARCH}-${PBUILD}" \
1625     "${BINDIR}_${PNAME}" || die "split_package: ${PNAME} package-build failed"
1626    
1627     # build pkg-md5-sum if requested
1628     generate_package_md5sum \
1629     --pcat "${PCATEGORIE}" \
1630     --pname "${PNAME}" \
1631     --pver "${PVER}" \
1632     --pbuild "${PBUILD}" \
1633     --parch "${ARCH}"
1634    
1635     echo -e "${COLGREEN}\nPackage ${PNAME}-${PVER}-${ARCH}-${PBUILD} successfully builded.\n${COLDEFAULT}"
1636    
1637     # restore smage environment
1638     split_restore_variables
1639     done
1640     # unset all saved smage variables
1641     split_unset_variables
1642    
1643   else   else
1644   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"   ${MLIBDIR}/pkgbuild_dir.sh ${PKGNAME} ${BINDIR} || die "package-build failed"
1645    
# Line 1258  case ${NOPKGBUILD} in Line 1655  case ${NOPKGBUILD} in
1655   fi   fi
1656    
1657   # build src-pkg-tarball if requested   # build src-pkg-tarball if requested
1658   [[ ${CREATE_SRC_PKG_TARBALL} = true ]] && source_pkg_build ${SMAGENAME}   mqueryfeature "srcpkg" && source_pkg_build ${SMAGENAME}
1659   ;;  fi
1660  esac  
1661    if mqueryfeature "buildlog"
1662  # for sure  then
1663  unset NOPKGBUILD   bzip2 -9f /var/log/smage/${PKGNAME}.log
1664  unset NOSTRIP  else
1665     [[ -f /var/log/smage/${PKGNAME}.log ]] && rm /var/log/smage/${PKGNAME}.log
1666    fi
1667    
1668  xtitleclean  xtitleclean

Legend:
Removed from v.497  
changed lines
  Added in v.1589